## mingw-w64-liberime-0.0.6-2.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

enable_language(C)
project(erime-core VERSION 0.1.0 DESCRIPTION "librime bindings for emacs")

set(CMAKE_POSITION_INDEPENDENT_CODE TRUE CACHE BOOL "pic" FORCE)
set(BUILD_SHARED_LIBS OFF CACHE BOOL "shared" FORCE)
set(BUILD_CLAR OFF CACHE BOOL "clar" FORCE)


add_library(erime-core SHARED "")


### Properties

set_target_properties(erime-core PROPERTIES C_STANDARD 99)

# Emacs looks for .so on linux and OSX.
# By default CMake builds .dylib on OSX, so override that.
if(APPLE)
  set_target_properties(erime-core PROPERTIES SUFFIX .so)
endif(APPLE)

if(WIN32)
  set_target_properties(erime-core PROPERTIES PREFIX lib)
endif(WIN32)


### Libraries and Includes

if (APPLE)
  if (NOT DEFINED ENV{RIME_PATH})
    message(FATAL_ERROR "Please set enviroment variable RIME_PATH to librime project dir.")
  endif()
  target_link_directories(erime-core PRIVATE "$ENV{RIME_PATH}/build/lib/Release/")
  target_link_directories(erime-core PRIVATE "$ENV{RIME_PATH}/build/lib/")
  target_include_directories(erime-core PRIVATE "$ENV{RIME_PATH}/src")
  target_link_libraries(erime-core PRIVATE rime)
elseif (UNIX)
  find_library(rime librime.so REQUIRED)
  target_link_libraries(erime-core PRIVATE rime)
elseif (MINGW)
  find_package(Rime REQUIRED)
  if (${Rime_FOUND})
    target_include_directories(erime-core PRIVATE ${Rime_INCLUDE_DIR})
    target_link_libraries(erime-core PRIVATE ${Rime_LIBRARIES})
  else()
    message(FATAL_ERROR "Can not found rime")
  endif()
endif()


### Compile options


if ("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
  set(CMAKE_C_FLAGS_DEBUG "-fuse-ld=gold -fsanitize=address,leak,undefined -fno-omit-frame-pointer -pg -g")
endif()

### Sources

target_sources(erime-core PRIVATE
  src/interface.c
  src/liberime-core.c
  src/init.c)

=== Makefile ===
EMACS=emacs
TYPE=Release

liberime-core:
        ifdef MINGW_PREFIX
	cmake -H. -Bbuild -G "MSYS Makefiles" -DCMAKE_BUILD_TYPE=${TYPE}
        else
	cmake -H. -Bbuild -DCMAKE_BUILD_TYPE=${TYPE}
        endif
	cmake --build build

clean:
	rm -rf build

test: liberime-core
	${EMACS} -Q -L build -L . liberime-test.el

ccls:
	cmake -H. -BDebug -DCMAKE_BUILD_TYPE=Debug \
		-DCMAKE_EXPORT_COMPILE_COMMANDS=YES

=== PKGBUILD ===
# Maintainer: Feng Shu <tumashu@163.com>

_realname=liberime
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=0.0.6
pkgrel=2
pkgdesc="An emacs dynamic module provide librime bindings for emacs (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64')
url="https://github.com/merrickluo/liberime"
license=('spdx:GPL-3.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-librime")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
source=("https://github.com/merrickluo/liberime/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz")
sha256sums=('52dd3e000402c3a5476755de053c097cd7b7a2bd4a2134d6019559629b508ebb')

build() {
  mkdir - "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    "${_extra_config[@]}" \
    "../${_realname}-${pkgver}"

  ${MINGW_PREFIX}/bin/cmake.exe --build ./
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  install -Dm644 liberime-core.dll ${pkgdir}${MINGW_PREFIX}/bin/liberime-core.dll
  install -Dm644 liberime-core.dll.a ${pkgdir}${MINGW_PREFIX}/lib/liberime-core.dll.a
  install -Dm644 ${srcdir}/${_realname}-${pkgver}/README.org ${pkgdir}${MINGW_PREFIX}/share/liberime/README.org
  install -Dm644 ${srcdir}/${_realname}-${pkgver}/liberime.el ${pkgdir}${MINGW_PREFIX}/share/emacs/site-lisp/liberime.el
}
